<?php
/**
 * Users Controller for S5ClanRoster Component
 * 
 * @package    
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

/**
 * Settings Controller
 */
class S5ClanRosterControllerS5Users extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'apply','save' );
		$this->registerTask( 'unblock', 'block' );		
	}

	/**
	 * display 
	 * @return void
	 */
	function display(){
		JRequest::setVar( 'view', 's5users' );
		JRequest::setVar( 'layout', 'default'  );
		//JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	/**
	 * html  for add new user
	 * @return void
	 */	
	function add(){
		$model 	=& $this->getModel( 's5users' );
		$view 	=& $this->getView( 's5users', '.html' );
		JRequest::setVar( 'view', 'user' );
		JRequest::setVar( 'edit', false );				
		$view->setModel( $model, true );
		$view->add();
	}	
	
	/**
	 * edit user
	 *
	 */
	function edit() {
		$model 	=& $this->getModel( 's5users' );
		$view 	=& $this->getView( 's5users', '.html' );
		JRequest::setVar( 'view', 'user' );		
		JRequest::setVar( 'edit', true );
		$view->setModel( $model, true );
		$view->edit();
	}
	
	/**
	 * edit user
	 *
	 */
	function block() {
		$model 	=& $this->getModel( 's5users' );
		$model->block();
		
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5users&controller=s5users');		
	}		
	
	/**
	 * return to main component
	 *
	 */
	function cancel() {
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5users&controller=s5users');
	}	
	
	/**
	 * save/edit new user
	 *
	 * @return unknown_type
	 */
	function save() {
		global $mainframe;
		
		$model =& $this->getModel('s5users');
		$cid = $model->save();
		
		if(JRequest::getVar('task') == 'apply' && $cid){
			if($cid != ''){
				$this->setRedirect('index.php?option=com_s5clanroster&view=s5users&controller=s5users&task=edit&cid[]='.$cid);
			}else{
				$this->setRedirect('index.php?option=com_s5clanroster&view=s5users&controller=s5users');			
			}
		}else{
			$this->setRedirect('index.php?option=com_s5clanroster&view=s5users&controller=s5users');
		}
	}
	
	/**
	 * delete a user
	 * @return void
	 */	
	function remove(){
		$model =& $this->getModel('s5users');
		$model->delete();
		
		$this->setRedirect( 'index.php?option=com_s5clanroster&view=s5users&controller=s5users', $msg);			
	}	
	
	/**
	 * delete a photo from user
	 * @return void
	 */	
	function delete_photo(){
		$cid 		= JRequest::getVar( 'cid', '' );
		$user_id 	= JRequest::getVar( 'user_id', '' );
		
		$model =& $this->getModel('s5users');
		$msg = $model->delete_photo();
		
		$this->setRedirect('index.php?option=com_s5clanroster&view=s5users&controller=s5users&task=edit&cid[]='.$user_id,$msg);
	}	
}
?>