<?php
/**
 * Users model for S5ClanRoster Component
 * 
 * @package     
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );
jimport( 'phpmailer.phpmailer' );
/**
 * Settings Model
 *
 * @package   
 * @subpackage Components
 */
class S5ClanRosterModelS5Users extends JModel
{

	/**
	 * save/edit new listing
	 *
	 * @return unknown_type
	 */
	function delete_photo() {
		global $mainframe;
		$cid 	= JRequest::getVar( 'cid', '' );
		$db 	=& JFactory::getDBO();
		
		if($cid != ''){
			include_once(JPATH_COMPONENT.DS."tables".DS."s5users.php");
			$row =& new TableS5Users($db);		
			$row->load($cid);
		}else{
			return JText::_("DELETE PHOTO EMPTY");
		}

		//delete photo
		 if(file_exists(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$row->user_photo)){
			if(unlink(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$row->user_photo)){
				$row->user_photo = '';
				if (!$row->delete($cid)) {
					$msg = JText::_("DELETE PHOTO ERROR");
				}else{
					$msg = JText::_("SUCC EDITED");
				}
			}else{
				$msg = JText::_("DELETE PHOTO ERROR");
			}
		 }

		return $msg;
	}	


	/**
	 * Display the param for this user
	 *
	 * @return html list
	 */	
	function getuser_photo() {
		global $mainframe, $option;
			
		$db	=& JFactory::getDBO();			
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		
		if(!empty($cid[0])){		
			// array where[]
			$where = array();
			$where[] = " user_id  = '".$cid[0]."'";
			
			// build query 's where
			$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );			
			
			// get list of param
			$sql = "SELECT * "
			."\n FROM `#__s5clanroster_users` "
			."\n ".$where;
			$db->setQuery($sql);
			$rows = $db->loadObjectList();

			if(!empty($rows)){
				$return = $rows[0];
			}else{
				$return = '';
			}
		}else{
			$return = '';
		}

		return $return; 	
	}

	/**
	 * Retrieves the users data
	 * @return array Array of objects containing the data from the database
	 */
	function getusers(){ 
	
		global $mainframe, $option;
		$db 			=& JFactory::getDBO(); 
		$config 		= new JConfig();
		$task 			= JArrayHelper::getValue( $_REQUEST, 'task', '' ); 
		$context		= $option."users";	
		
		$filter_order		= $mainframe->getUserStateFromRequest( $context."filter_order",		'filter_order',		'a.name',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context."filter_order_Dir",	'filter_order_Dir',	'',			'word' );
		$filter_type		= $mainframe->getUserStateFromRequest( $context."filter_type",		'filter_type', 		0,			'string' );
		$search				= $mainframe->getUserStateFromRequest( $context."search",			'search', 			'',			'string' );
		$search				= JString::strtolower( $search );
		
		$limit 			= intval( $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int' ) );
		$limitstart 	= intval( $mainframe->getUserStateFromRequest( "limitstart", 'limitstart', 0, 'int' ) );
		
		$where = array();
		$filter = '';		
		if (isset( $search ) && $search!= '')
		{
			$searchEscaped = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = 'a.username LIKE '.$searchEscaped.' OR a.email LIKE '.$searchEscaped.' OR a.name LIKE '.$searchEscaped;
		}
		if ( $filter_type )
		{
			if ( $filter_type == 'Public Frontend' )
			{
				$where[] = ' a.usertype = \'Registered\' OR a.usertype = \'Author\' OR a.usertype = \'Editor\' OR a.usertype = \'Publisher\' ';
			}
			else if ( $filter_type == 'Public Backend' )
			{
				$where[] = 'a.usertype = \'Manager\' OR a.usertype = \'Administrator\' OR a.usertype = \'Super Administrator\' ';
			}
			else
			{
				$where[] = 'a.usertype = LOWER( '.$db->Quote($filter_type).' ) ';
			}
		}
		
		// build query 's order
		$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;
		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );		
		
		// Get the total records
		$query = 'SELECT COUNT(a.id)'
		. ' FROM #__users AS a'
		. $filter
		. $where		
		;
		$db->setQuery( $query );
		$total = $db->loadResult();
		//generate error msg		
		if ($db->getErrorNum()) {
			echo $db->stderr();
			exit;
		}
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );

		$query = 'SELECT a.*, g.name AS groupname'
			. ' FROM #__users AS a'
			. ' INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id'
			. ' INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id'
			. ' INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id'
			. $filter
			. $where			
			. ' GROUP BY a.id'
			. $orderby
		;
		$db->setQuery( $query, $pagination->limitstart, $pagination->limit );
		$rows = $db->loadObjectList();		
		
		// get list of Groups for dropdown filter
		$query = 'SELECT name AS value, name AS text'
			. ' FROM #__core_acl_aro_groups'
			. ' WHERE name != "ROOT"'
			. ' AND name != "USERS"'
		;
		$db->setQuery( $query );
		$types[] = JHTML::_('select.option',  '0', '- '. JText::_( 'Select Group' ) .' -' );
		foreach( $db->loadObjectList() as $obj )
		{
			$types[] = JHTML::_('select.option',  $obj->value, JText::_( $obj->text ) );
		}
		$lists['type'] 	= JHTML::_('select.genericlist',   $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_type" );
		
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;

		$return = array("items"=>$rows,"pageNav"=>$pagination,"lists"=>$lists);
		
		return $return;
	}
	
	/**
	 * Retrieves the users data
	 * @return array Array of objects containing the data from the database
	 */	
	function getuser(){
		$cid		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));
		$edit		= JRequest::getVar('edit',true);		
		$me 		= JFactory::getUser();
		$db 		=& JFactory::getDBO();
		
		if($edit)
			$user 		=& JUser::getInstance( $cid[0] );
		else
			$user 		=& JUser::getInstance();

		// Check for post data in the event that we are returning
		// from a unsuccessful attempt to save data		
		$post = JRequest::get('post');
		if ( $post ) {
			$user->bind($post);
		}
		
		$myuser		=& JFactory::getUser();
		$acl		=& JFactory::getACL();

		// Check for post data in the event that we are returning
		// from a unsuccessful attempt to save data
		$post = JRequest::get('post');
		if ( $post ) {
			$user->bind($post);
		}

		if ( $user->get('id'))
		{
			$query = 'SELECT *'
			. ' FROM #__contact_details'
			. ' WHERE user_id = '.(int) $cid[0]
			;
			$db->setQuery( $query );
			$contact = $db->loadObjectList();
		}
		else
		{
			$contact 	= NULL;
			// Get the default group id for a new user
			$config		= &JComponentHelper::getParams( 'com_users' );
			$newGrp		= $config->get( 'new_usertype' );
			$user->set( 'gid', $acl->get_group_id( $newGrp, null, 'ARO' ) );
		}

		$userObjectID 	= $acl->get_object_id( 'users', $user->get('id'), 'ARO' );
		$userGroups 	= $acl->get_object_groups( $userObjectID, 'ARO' );
		$userGroupName 	= strtolower( $acl->get_group_name( $userGroups[0], 'ARO' ) );

		$myObjectID 	= $acl->get_object_id( 'users', $myuser->get('id'), 'ARO' );
		$myGroups 		= $acl->get_object_groups( $myObjectID, 'ARO' );
		$myGroupName 	= strtolower( $acl->get_group_name( $myGroups[0], 'ARO' ) );;

		if ( $userGroupName == $myGroupName && $myGroupName == 'administrator' )
		{
			// administrators can't change each other
			$lists['gid'] = '<input type="hidden" name="gid" value="'. $user->get('gid') .'" /><strong>'. JText::_( 'Administrator' ) .'</strong>';
		}
		else
		{
			$gtree = $acl->get_group_children_tree( null, 'USERS', false );

			// remove users 'above' me
			//$i = 0;
			//while ($i < count( $gtree )) {
			//	if ( in_array( $gtree[$i]->value, (array)$excludeGroups ) ) {
			//		array_splice( $gtree, $i, 1 );
			//	} else {
			//		$i++;
			//	}
			//}

			$lists['gid'] 	= JHTML::_('select.genericlist',   $gtree, 'gid', 'size="10"', 'value', 'text', $user->get('gid') );
		}

		// build the html select list
		$lists['block'] 	= JHTML::_('select.booleanlist',  'block', 'class="inputbox" size="1"', $user->get('block') );

		// build the html select list
		$lists['sendEmail'] = JHTML::_('select.booleanlist',  'sendEmail', 'class="inputbox" size="1"', $user->get('sendEmail') );
		

		$return = array("user"=>$user,"lists"=>$lists);
		
		return $return;		
	}
	
	/**
	 * Saves the user
	 */
	function save(){
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$option = JRequest::getCmd( 'option');

		// Initialize some variables
		$mosConfig_absolute_path= JPATH_ROOT;
		$mosConfig_live_site 	= JURI :: root();		
		$db						= & JFactory::getDBO();
		$me						= & JFactory::getUser();
		$acl					=& JFactory::getACL();
		$MailFrom				= $mainframe->getCfg('mailfrom');
		$FromName				= $mainframe->getCfg('fromname');
		$SiteName				= $mainframe->getCfg('sitename');
		$user_id 				= JRequest::getVar( 'id', 0, 'post', 'int');
		$extra_fields 			= JRequest::getVar( 'extra_fields', '');
		$categories_selected	= JRequest::getVar( 'categories_selected', '');		

 		// Create a new JUser object
		$user = new JUser($user_id);
		$original_gid = $user->get('gid');

		$post = JRequest::get('post');
		$post['username']	= JRequest::getVar('username', '', 'post', 'username');
		$post['password']	= JRequest::getVar('password', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['password2']	= JRequest::getVar('password2', '', 'post', 'string', JREQUEST_ALLOWRAW);

		if (!$user->bind($post))
		{
			$mainframe->enqueueMessage(JText::_('CANNOT SAVE THE USER INFORMATION'), 'message');
			$mainframe->enqueueMessage($user->getError(), 'error');
			//$mainframe->redirect( 'index.php?option=com_users', $user->getError() );
			return false;
			//return $this->execute('edit');
		}

		$objectID 	= $acl->get_object_id( 'users', $user->get('id'), 'ARO' );
		$groups 	= $acl->get_object_groups( $objectID, 'ARO' );
		$this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );

		if ( $user->get('id') == $me->get( 'id' ) && $user->get('block') == 1 )
		{
			$msg = JText::_( 'You cannot block Yourself!' );
			$mainframe->enqueueMessage($msg, 'message');
			return false;
		}
		else if ( ( $this_group == 'super administrator' ) && $user->get('block') == 1 ) {
			$msg = JText::_( 'You cannot block a Super Administrator' );
			$mainframe->enqueueMessage($msg, 'message');
			return false;
		}
		else if ( ( $this_group == 'administrator' ) && ( $me->get( 'gid' ) == 24 ) && $user->get('block') == 1 )
		{
			$msg = JText::_( 'WARNBLOCK' );
			$mainframe->enqueueMessage($msg, 'message');
			return false;
		}
		else if ( ( $this_group == 'super administrator' ) && ( $me->get( 'gid' ) != 25 ) )
		{
			$msg = JText::_( 'You cannot edit a super administrator account' );
			$mainframe->enqueueMessage($msg, 'message');
			return false;
		}
		// Are we dealing with a new user which we need to create?
		$isNew 	= ($user->get('id') < 1);
		if (!$isNew)
		{
			// if group has been changed and where original group was a Super Admin
			if ( $user->get('gid') != $original_gid && $original_gid == 25 )
			{
				// count number of active super admins
				$query = 'SELECT COUNT( id )'
					. ' FROM #__users'
					. ' WHERE gid = 25'
					. ' AND block = 0'
				;
				$db->setQuery( $query );
				$count = $db->loadResult();

				if ( $count <= 1 )
				{
					// disallow change if only one Super Admin exists
					$this->setRedirect( 'index.php?option=com_users', JText::_('WARN_ONLY_SUPER') );
					return false;
				}
			}
		}

		//
	 	 // Lets save the JUser object
	 	 //
		if (!$user->save())
		{
			$mainframe->enqueueMessage(JText::_('CANNOT SAVE THE USER INFORMATION'), 'message');
			$mainframe->enqueueMessage($user->getError(), 'error');
			return false;
		}
		//
	 	 // Time for the email magic so get ready to sprinkle the magic dust...
	 	 //
		if ($isNew)
		{
			$adminEmail = $me->get('email');
			$adminName	= $me->get('name');

			$subject = JText::_('NEW_USER_MESSAGE_SUBJECT');
			$message = sprintf ( JText::_('NEW_USER_MESSAGE'), $user->get('name'), $SiteName, JURI::root(), $user->get('username'), $user->password_clear );

			if ($MailFrom != '' && $FromName != '')
			{
				$adminName 	= $FromName;
				$adminEmail = $MailFrom;
			}
			
			//JUtility::sendMail( $adminEmail, $adminName, $user->get('email'), $subject, $message );
				// Get a JMail instance
				$mail =& JFactory::getMailer();
				$mail->SetLanguage('en', $mosConfig_absolute_path."/administrator/components/com_s5clanroster/language/");	
				
				$mail->setSender(array($adminEmail, $adminName));
				$mail->setSubject($subject);
				$mail->setBody($message);
		
				// Are we sending the email as HTML?
				if ( $mode ) {
					$mail->IsHTML(true);
				}
				$mail->addRecipient($user->get('email'));
				$mail->Send();			
		}

		// If updating self, load the new user object into the session
		if ($user->get('id') == $me->get('id'))
		{
			// Get an ACL object
			$acl = &JFactory::getACL();

			// Get the user group from the ACL
			$grp = $acl->getAroGroup($user->get('id'));

			// Mark the user as logged in
			$user->set('guest', 0);
			$user->set('aid', 1);

			// Fudge Authors, Editors, Publishers and Super Administrators into the special access group
			if ($acl->is_group_child_of($grp->name, 'Registered')      ||
			    $acl->is_group_child_of($grp->name, 'Public Backend'))    {
				$user->set('aid', 2);
			}

			// Set the usertype based on the ACL group name
			$user->set('usertype', $grp->name);

			$session = &JFactory::getSession();
			$session->set('user', $user);
		}

		//end joomla core save user function
		//begin S5ClanRoster code
		//upload photo
		if(isset($_FILES["user_photo"]["name"]) && !empty($_FILES["user_photo"]["name"])){
			//upload new images
			$return_upload_photo = S5ClanRosterHelpers::add_photo($user->username,$user->id);
			if(!empty($return_upload_photo["image"])){
				//add image to db
				$row_photo 				=& $this->getTable();
/*				if($user_id > 0 && $row_photo->load($user_id)){
					$row_photo->SetPrimary($db,'user_id');
				}*/
				$row_photo->user_id 	= $user->id;
				$row_photo->user_photo 	= $return_upload_photo["image"];
				if (!$row_photo->store()) {
					$mainframe->enqueueMessage(JText::_("ERROR ADD PHOTO"), 'error');
					return false;
				}
			}else{
				$mainframe->enqueueMessage(JText::_("ERROR ADD PHOTO"), 'error');
				return false;
			}
		}

		//add user to category	
		include_once(JPATH_COMPONENT.DS."tables".DS."s5clanroster.php");
		$row_cat =& new TableS5ClanRoster($db);					

		if($user_id > 0){
			//update user's categories
			//first delete from all categories this user id
			$query = 'SELECT id'
			. ' FROM #__s5clanroster_categories'
			;
			$db->setQuery( $query );
			$categories_users = $db->loadObjectList();
			foreach($categories_users as $categories_users_row => $categories_users_value){
				$row_cat->load( (int) $categories_users_value->id );
				if($row_cat->user_id != ''){			
					$existing_users = explode(",",$row_cat->user_id);
					//add this new user
					$key = array_search($user_id, $existing_users);
					if($key !== false){
						unset($existing_users[$key]);
					}
					$row_cat->user_id = implode(",",$existing_users);
				}
				$row_cat->store();
			}
		}

		$category = JRequest::getVar( 'category', array(), '', 'array' );
		foreach($category as $category_row => $category_value){
			//get all users from this category
			$row_cat->load( (int) $category_value );
			if($row_cat->user_id != ''){			
				$existing_users = explode(",",$row_cat->user_id);
				//add this new user
				//array_push($existing_users, $user->id);
				$existing_users[] = $user->id;
				$existing_users = array_unique($existing_users);
				$row_cat->user_id = implode(",",$existing_users);
			}else{
				$row_cat->user_id = $user->id;
			}
			
			if (!$row_cat->store()) {
				$mainframe->enqueueMessage(JText::_("ERROR ADD CATEGORY"), 'error');
				return false;
			}
		}
		
		//save category extra fields
		include_once(JPATH_COMPONENT.DS."tables".DS."s5param_users.php");
		//delete old records for this user
		$query = 'DELETE '
		. ' FROM #__s5clanroster_param_users'
		. ' WHERE `user_id`= "'.$user->id.'"';
		$db->setQuery( $query );
		$db->Query();
					
		$extra_fields_array = explode(",",$extra_fields);
		foreach($extra_fields_array as $extra_fields_array_row => $extra_fields_array_value){
			if(JRequest::getVar($extra_fields_array_value, '') != ''){
				$row_param =& new TableS5ParamUsers($db);
				$row_param->param_value = JRequest::getVar($extra_fields_array_value, '');
				$row_param->user_id = $user->id;
				//generate cat_id and param_id
				$cat_param_id = explode("_",$extra_fields_array_value);
				$row_param->cat_id = $cat_param_id[0];
				$row_param->param_id = $cat_param_id[1];
				$row_param->store();
			}
		}

		return $user->id;
	}
	
	/**
	 * delete user
	 *
	 * @return unknown_type
	 */
	function delete() {
	
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$db 			=& JFactory::getDBO();
		$currentUser 	=& JFactory::getUser();
		$acl			=& JFactory::getACL();
		$cid 			= JRequest::getVar( 'cid', array(), '', 'array' );

		JArrayHelper::toInteger( $cid );

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select a User to delete', true ) );
		}

		foreach ($cid as $id)
		{
			// check for a super admin ... can't delete them
			$objectID 	= $acl->get_object_id( 'users', $id, 'ARO' );
			$groups 	= $acl->get_object_groups( $objectID, 'ARO' );
			$this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );

			$success = false;
			if ( $this_group == 'super administrator' )
			{
				$msg = JText::_( 'You cannot delete a Super Administrator' );
			}
			else if ( $id == $currentUser->get( 'id' ) )
			{
				$msg = JText::_( 'You cannot delete Yourself!' );
			}
			else if ( ( $this_group == 'administrator' ) && ( $currentUser->get( 'gid' ) == 24 ) )
			{
				$msg = JText::_( 'WARNDELETE' );
			}
			else
			{
				$user =& JUser::getInstance((int)$id);
				$count = 2;

				if ( $user->get( 'gid' ) == 25 )
				{
					// count number of active super admins
					$query = 'SELECT COUNT( id )'
						. ' FROM #__users'
						. ' WHERE gid = 25'
						. ' AND block = 0'
					;
					$db->setQuery( $query );
					$count = $db->loadResult();
				}

				if ( $count <= 1 && $user->get( 'gid' ) == 25 )
				{
					// cannot delete Super Admin where it is the only one that exists
					$msg = "You cannot delete this Super Administrator as it is the only active Super Administrator for your site";
				}
				else
				{
					// delete user
					$user->delete();
					$msg = '';

					JRequest::setVar( 'task', 'remove' );
					JRequest::setVar( 'cid', $id );

					// delete user acounts active sessions
					//$this->logout();
					
					include_once(JPATH_COMPONENT.DS."tables".DS."s5clanroster.php");
					$row_cat =& new TableS5ClanRoster($db);						
					
					//update user's categories
					//first delete from all categories this user id
					$query = 'SELECT id'
					. ' FROM #__s5clanroster_categories'
					;
					$db->setQuery( $query );
					$categories_users = $db->loadObjectList();
					foreach($categories_users as $categories_users_row => $categories_users_value){
						$row_cat->load( (int) $categories_users_value->id );
						if($row_cat->user_id != ''){			
							$existing_users = explode(",",$row_cat->user_id);
							//add this new user
							$key = array_search($id, $existing_users);
							if($key >= 0){
								unset($existing_users[$key]);
							}
							$row_cat->user_id = implode(",",$existing_users);
						}
						$row_cat->store();
					}
					
					//delete photo for this user
					$row_photo =& $this->getTable();
					$row_photo->SetPrimary($db,'user_id');
					$row_photo->load($id);
					if(file_exists(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$row_photo->user_photo)){
						@unlink(JPATH_ROOT.DS."images".DS."stories".DS."s5clanroster_photos".DS.$row_photo->user_photo);
					}
					$row_photo->delete();
				}
			}
		}
		return $msg;
	}
	
	/**
	 * Disables the user account
	 */
	function block( )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$db 			=& JFactory::getDBO();
		$acl			=& JFactory::getACL();
		$currentUser 	=& JFactory::getUser();

		$cid 	= JRequest::getVar( 'cid', array(), '', 'array' );
		$task 	= JRequest::getVar( 'task', '');
		//$block  = $this->getTask() == 'block' ? 1 : 0;
		$block  = $task == 'block' ? 1 : 0;

		JArrayHelper::toInteger( $cid );

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select a User to '.$this->getTask(), true ) );
		}
		foreach ($cid as $id)
		{
			// check for a super admin ... can't delete them
			$objectID 	= $acl->get_object_id( 'users', $id, 'ARO' );
			$groups 	= $acl->get_object_groups( $objectID, 'ARO' );
			$this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );

			$success = false;
			if ( $this_group == 'super administrator' )
			{
				$msg = JText::_( 'You cannot block a Super Administrator' );
			}
			else if ( $id == $currentUser->get( 'id' ) )
			{
				$msg = JText::_( 'You cannot block Yourself!' );
			}
			else if ( ( $this_group == 'administrator' ) && ( $currentUser->get( 'gid' ) == 24 ) )
			{
				$msg = JText::_( 'WARNBLOCK' );
			}
			else
			{
				$user =& JUser::getInstance((int)$id);
				$count = 2;

				if ( $user->get( 'gid' ) == 25 )
				{
					// count number of active super admins
					$query = 'SELECT COUNT( id )'
						. ' FROM #__users'
						. ' WHERE gid = 25'
						. ' AND block = 0'
					;
					$db->setQuery( $query );
					$count = $db->loadResult();
				}

				if ( $count <= 1 && $user->get( 'gid' ) == 25 )
				{
					// cannot delete Super Admin where it is the only one that exists
					$msg = "You cannot block this Super Administrator as it is the only active Super Administrator for your site";
				}
				else
				{
					$user =& JUser::getInstance((int)$id);
					$user->block = $block;
					$user->save();

					if($block)
					{
						JRequest::setVar( 'task', 'block' );
						JRequest::setVar( 'cid', array($id) );

						// delete user acounts active sessions
						//$this->logout();
					}
				}
			}
		}

		return true;
	}	
}
?>