<?php
/**
 * Category View for S5ClanRoster Component
 * 
 * @package
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * category View
 *
 * @package
 * @subpackage Components
 */
class S5ClanRosterViewS5ClanRoster extends JView
{
	/**
	 * category view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
		JToolBarHelper::title(   JText::_( 'TITLE CATEGORIES' ), 'generic.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::customX( 'copyselect', 'copy.png', 'copy_f2.png', 'Copy', true );
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();

		// Get data from the model
		$return	= & $this->get( 'items');
		$this->assignRef('rows', $return['items']);
		$this->assignRef('pageNav', $return['pageNav']);
		$this->assignRef('lists', $return['lists']);

		parent::display($tpl);
	}
	
	/**
	 * add / edit a category
	 * 
	 * @param $tpl
	 * @return unknown_type
	 */
	function add($tpl = null) { 
		JToolBarHelper::title(   JText::_( 'TITLE NEW CATEGORY' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();

		$this->setLayout('add');
		parent::display($tpl);
	}
	
	/**
	 * copy a category
	 * 
	 * @param $tpl
	 * @return unknown_type
	 */
	function copy($tpl = null) { 
		JToolBarHelper::title(   JText::_( 'TITLE NEW CATEGORY' ), 'generic.png' );
		JToolBarHelper::Save('savecopy');
		JToolBarHelper::Cancel();

		$item = $this->get('copy_item');
		$this->assignRef('item', $item);

		$this->setLayout('copy');
		parent::display($tpl);
	}		
	
	/**
	 * edit category
	 *
	 */
	function edit($tpl = null) {
		JToolBarHelper::title(   JText::_( 'TITLE EDIT CATEGORY' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();
		
		$item = $this->get('item');
		$this->assignRef('item', $item);

		$category_user_param = $this->get( 'category_user_param');
		$this->assignRef('category_user_param', $category_user_param);
		
		$category_param = $this->get( 'category_param');
		$this->assignRef('category_param', $category_param);		

		$this->setLayout('add');
		parent::display($tpl);
	}	
}
?>