<?php
/**
* @license GNU/GPL, see LICENSE.php
* Site: www.shape5.com
* Email: contact@shape5.com
* @copyright (C) 2009 Shape 5
*
*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');

/**
 * Component Controller
 *
 * @package	
 */
class S5ClanRosterController extends JController
{
	/**
	 * Method to display the home page
	 *
	 * @access	public
	 */
	function display()
	{
		parent::display();
	}
	
	/**
	 * display category
	 * @return void
	 */
	function category(){
		$model 	=& $this->getModel( 's5clanroster' );
		$view 	=& $this->getView( 's5clanroster', '.html' );
		$view->setModel( $model, true );
		$view->category();
	}
	
	/**
	 * display edit page
	 * @return void
	 */
	function edit(){
		$user		= JFactory::getUser();
		$user_id 	= JRequest::getVar( 'user_id', '', '', 'int' );
		if ($user->get('id') == 0 || $user_id == 0 || $user_id <> $user->get('id')) {
			JError::raiseError( 403, JText::_('Access Forbidden') );
			return;
		}else{
			$model 	=& $this->getModel( 's5clanroster' );
			$view 	=& $this->getView( 's5clanroster', '.html' );
			$view->setModel( $model, true );
			$view->edit();
		}
	}	
	
	/**
	 * delete a photo from user
	 * @return void
	 */	
	function delete_photo(){
		$cid 		= JRequest::getVar( 'cid', '', '', 'int' );
		$cat_id		= JRequest::getVar( 'cat_id', '', '', 'int' );
		$user_id 	= JRequest::getVar( 'user_id', '', '', 'int' );
		$Itemid		= JRequest::getVar( 'Itemid', '', '', 'int' );
		
		$model = $this->getModel('s5clanroster');
		$msg = $model->delete_photo();
		
		$this->setRedirect(JRoute::_('index.php?option=com_s5clanroster&view=s5clanroster&task=edit&cat_id='.$cat_id.'&user_id='.$user_id.'&Itemid='.$Itemid, false),$msg);
	}
	
	/**
	 * save/edit user
	 *
	 * @return unknown_type
	 */
	function save() {
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$user	 =& JFactory::getUser();
		$cat_id	 = JRequest::getVar( 'cat_id', '', '', 'int' );
		$userid  = JRequest::getVar( 'id', 0, 'post', 'int' );
		$Itemid	 = JRequest::getVar( 'Itemid', '', '', 'int' );		

		// preform security checks
		if ($user->get('id') == 0 || $userid == 0 || $userid <> $user->get('id')) {
			JError::raiseError( 403, JText::_('Access Forbidden') );
			return;
		}

		//clean request
		$post = JRequest::get( 'post' );
		$post['username']	= JRequest::getVar('username', '', 'post', 'username');
		$post['password']	= JRequest::getVar('password', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['password2']	= JRequest::getVar('password2', '', 'post', 'string', JREQUEST_ALLOWRAW);
	
		// get the redirect
		$return = JURI::base();
		
		// do a password safety check
		if(strlen($post['password']) || strlen($post['password2'])) { // so that "0" can be used as password e.g.
			if($post['password'] != $post['password2']) {
				$msg	= JText::_('PASSWORDS_DO_NOT_MATCH');
				// something is wrong. we are redirecting back to edit form.
				// TODO: HTTP_REFERER should be replaced with a base64 encoded form field in a later release
				$return = str_replace(array('"', '<', '>', "'"), '', @$_SERVER['HTTP_REFERER']);
				if (empty($return) || !JURI::isInternal($return)) {
					$return = JURI::base();
				}
				$this->setRedirect(JRoute::_('index.php?option=com_s5clanroster&view=s5clanroster&task=edit&cat_id='.$cat_id.'&user_id='.$userid.'&Itemid='.$Itemid, false), $msg, 'error');
				return false;
			}
		}

		// we don't want users to edit certain fields so we will unset them
		unset($post['gid']);
		unset($post['block']);
		unset($post['usertype']);
		unset($post['registerDate']);
		unset($post['activation']);

		// store data
		$model = $this->getModel('s5clanroster');

		if ($model->store($post)) {
			$msg	= JText::_( 'Your settings have been saved.' );
		} else {
			//$msg	= JText::_( 'Error saving your settings.' );
			$msg	= $model->getError();
		}

		$this->setRedirect(JRoute::_('index.php?option=com_s5clanroster&view=s5clanroster&task=edit&cat_id='.$cat_id.'&user_id='.$userid.'&Itemid='.$Itemid, false), $msg);

	}	
}
?>
