<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();	

jimport( 'joomla.application.component.view');
jimport( 'joomla.application.module.helper' );

/**
 * HTML View class for the S5ClanRoster Component
 *
 */

class S5ClanRosterViewS5ClanRoster extends JView
{
	/**
	 * Method to display the home page
	 *
	 * @access	public
	 */
	function display($tpl = null){
		$db	=& JFactory::getDBO();
	
		//get all categories in order to display category list
		$category_parent_list	 = $this->get( 'category_parent_list' );
		foreach($category_parent_list as $category_row => $category){
			// get list of param
			$sql = "SELECT user_param "
			."\n FROM `#__s5clanroster_categories` "
			."\n WHERE `id` = '".$category->id."'";
			$db->setQuery($sql);
			$rows = $db->loadObjectList();
			
			if($rows[0]->user_param != ''){
				$user_param = explode("\n",$rows[0]->user_param);
				$return = array();
				foreach($user_param as $user_param_row => $user_param_value){
					$return_values = explode("=",$user_param_value);
					$return[$return_values[0]] = $return_values[1];
				}
			}
			$category_parent_list[$category_row]->param = $return;			
		}
		
		//get all categories settings
		$category_settings	 = $this->get( 'category_settings' );
		$this->assignRef( 'category_settings',	$category_settings[0] );		
		
		$this->assignRef( 'category_parent_list',	$category_parent_list );

		// Get the PathWay object from the application
		//$this->get('pathway');
		
		$list	= $this->get('S5List');
		$this->assignRef( 'pathway_list',	$list );
		$count	= count($list);
		$this->assignRef( 'pathway_count',	$count );
		$separator	= $this->get('S5Separator');
		$this->assignRef( 'pathway_separator',	$separator );		

		$document =& JFactory::getDocument();	
		//$document->addScript('components/com_s5clanroster/helpers/helper.js');
		$document->addStyleSheet('components/com_s5clanroster/css/s5clanroster.css');		
					
		parent::display($tpl);	
	}
	
	/**
	 * Method to display the category page
	 *
	 * @access	public
	 */
	function category($tpl = null){
		$db	=& JFactory::getDBO();
		global $mainframe;
			
		//get all categories items
		$category_items	 = $this->get( 'category_items' );
		$this->assignRef( 'category_items',	$category_items["return_users"] );
		$this->assignRef( 'pageNav', $category_items["pageNav"] );		
		
		//get all child categories
		$category_childs = $this->get( 'category_childs' );
		if(is_array($category_childs)){
			foreach($category_childs as $category_row => $category){
				// get list of param
				$sql = "SELECT user_param "
				."\n FROM `#__s5clanroster_categories` "
				."\n WHERE `id` = '".$category->id."'";
				$db->setQuery($sql);
				$rows = $db->loadObjectList();
				
				if($rows[0]->user_param != ''){
					$user_param = explode("\n",$rows[0]->user_param);
					$return = array();
					foreach($user_param as $user_param_row => $user_param_value){
						$return_values = explode("=",$user_param_value);
						$return[$return_values[0]] = $return_values[1];
					}
				}
				$category_childs[$category_row]->param = $return;			
			}		
		}
		$this->assignRef( 'category_childs',	$category_childs );			
		
		//get all categories settings
		$category_settings	 = $this->get( 'category_settings' );
		$this->assignRef( 'category_settings',	$category_settings[0] );
		
		$category_title	 = $this->get( 'category_title' );
		$this->assignRef( 'category_title',	$category_title[0] );	
		
		$document =& JFactory::getDocument();	
		$document->addStyleSheet('components/com_s5clanroster/css/s5clanroster.css');	
		
		// Get the PathWay object from the application
		$this->get('pathway');
	
		$list	= $this->get('S5List');
		$this->assignRef( 'pathway_list',	$list );
		$count	= count($list);
		$this->assignRef( 'pathway_count',	$count );
		$separator	= $this->get('S5Separator');
		$this->assignRef( 'pathway_separator',	$separator );		
	
		$this->setLayout('category');
		parent::display($tpl);	
	}	
	
/******* Edit scripts *********/

	/**
	 * Method to display the edit page
	 *
	 * @access	public
	 */
	function edit($tpl = null){
	
		// Load the form validation behavior
		JHTML::_('behavior.formvalidation');

		$user =& JFactory::getUser();
		$this->assignRef('user', $user);
		
		$user_photo = $this->get('user_photo');
		$this->assignRef('user_photo', $user_photo);	
		
		$user_fields = $this->get('user_fields');
		$this->assignRef('user_fields', $user_fields['return']);
		$this->assignRef('extra_fields', $user_fields['extra_fields']);		
		
		$this->assignRef('cat_id', JRequest::getVar( 'cat_id', '', '', 'int' ));		
		
		$document =& JFactory::getDocument();	
		//$document->addScript('components/com_s5clanroster/helpers/helper.js');
		$document->addStyleSheet('components/com_s5clanroster/css/s5clanroster.css');		

		//get all categories settings
		$category_settings	 = $this->get( 'category_settings' );
		$this->assignRef( 'category_settings',	$category_settings[0] );

		// Get the PathWay object from the application
		$this->get('pathway');
	
		$list	= $this->get('S5List');
		$this->assignRef( 'pathway_list',	$list );
		$count	= count($list);
		$this->assignRef( 'pathway_count',	$count );
		$separator	= $this->get('S5Separator');
		$this->assignRef( 'pathway_separator',	$separator );	

		$this->setLayout('edit');
		parent::display($tpl);	
	}	
}
?>
